package util

const (
	// Cobra Flags
	FlagRemote     = "remote"
	FlagConfig     = "config"
	FlagPath       = "projectPath"
	FlagLogLevel   = "logLevel"
	FlagProjectID  = "projectID"
	FlagCacheForce = "force"
	FlagOwnerOnly  = "ownerOnly"
	FlagAll        = "all"
	FlagCurrent    = "current"
	FlagPrompt     = "prompt"
	FlagWrite      = "write"
	FlagSensitive  = "sensitive"
	FlagDocsPath   = "docsPath"

	// Viper config bindings
	ViperAliasAddPID        = "alias.add.projectID"
	ViperCacheUnlockForce   = "cache.unlock.force"
	ViperCacheLoadOwnerOnly = "cache.load.ownerOnly"
	ViperProjectListAll     = "project.list.all"
	ViperProjectShowCurrent = "project.show.current"
)

const (
	DefGitlabHost    = "https://gitlab.com"
	DefLogLevel      = "info"
	DefConfigPath    = "~/.config/git-project-manager.yaml"
	ConfigName       = "git-project-manager"
	LegacyConfigName = "gitlab-project-manager"
)

const AliasCmdLong = `Manages project aliases, with options for
listing, adding, and deleting.`

const AliasListCmdLong = `Lists all aliases by project`

const AliasAddCmdLong = `Adds a project alias to a project
project ID can be provided, or will otherwise use fuzzy find`

const AliasDeleteCmdLong = `Deletes aliases from projects
project ID can be provided, or will otherwise use fuzzy find`

const CacheCmdLong = `Contains sub-commands for managing project cache.
The project cache keeps this speedy, without smashing against the Git
API every time a new project is added / searched for`

const RootCmdLong = `Finds Git projects using fuzzy-find, remembering
your chosen term for the project as an alias, and offers helpful
shortcuts for moving around in projects and opening your code`

const ProjCmdLong = `Switches to a Git project by name or alias
If not found, will enter fzf mode. If not cloned, will clone
the project locally.`

const ProjGoCmdLong = `Go to a project, searching by alias
If project is not already cloned, its path will be built and it
will be cloned from source control.

If conf.projects.alwaysPull, a git pull will be ran automatically`

const ProjRunCmdLong = `Runs the current project. Tries to detect
the language and runs accordingly (e.g. go run .)`

const ProjListCmdLong = `List locally cloned projects. Optionally
lists all projects in project cache`

const ProjAddCmdLong = `Adds a new project to the local project path
uses fuzzy find to locate the project`

const ProjShowCmdLong = `Shows detail for a particular project
Will always fuzzy find`

const ProjOpenCmdLong = `Opens the given project directory in the editor
of your choice. Will find certain well-known entrypoints (e.g. main.go).

If your editor is set in your config file, it will be used, otherwise
one will be found in your path from a list of known defaults.`

const ConfigCmdLong = `Commands for managing configuration, particulary
useful for seeding a new config file`

const ConfigGenCmdLong = `Produces yaml to stdout that can be used
to seed the configuration file`
